#ifndef __MACROS_H__
#define __MACROS_H__

#include <iostream>
#include <string>

//#define MASKED
//#define GCCOUNT
#define REVERSED
#define ACGTONLY


/*
 * (I) Usefull functions
 */

#define ASSERT(ptr)                                                   \
  if (!(ptr)){                                                        \
    cerr << "*ERROR : memory allocation failed on" << #ptr <<   endl; \
    exit(-1);                                                         \
  }

#define ERROR(message1,message2){                                   \
    cerr << "*ERROR : " << #message1 << " : " << #message2 << endl; \
    exit(-1);                                                       \
  }


#define MAX(a,b) ((a)>(b)?(a):(b)) 
#define MAX3(a,b,c) MAX((a),MAX((b),(c)))
#define MIN(a,b) ((a)<(b)?(a):(b))
#define MIN3(a,b,c) MIN((a),MIN((b),(c)))
#define ABS(a) ((a)>=0?(a):(-a))

/*
 * to ouptut nucleotides "unsigned char" in a human readable format
 */

std::ostream& operator<<(std::ostream& os, unsigned char code);
void nucleotides(std::ostream& os, unsigned char code, int remain=4, unsigned char mask=0x00);


#define POS_INFINITY   (0x7fff0000)  
#define NEG_INFINITY   (0x8000ffff)


/*
 *  (II) Constants
 */

#define _M_       32
#define _K_        5

#define FALSE      0
#define TRUE       1
#define KILO      (1024)
#define MEGA      (KILO*KILO)
#define GIGA      (MEGA*KILO)



/*
 *  (III) specific definitions 
 */

#define SEEDCODE    unsigned long long
#define SEEDCOUNT   unsigned long long

#endif
